]> Git Repo - linux.git/blame - scripts/link-vmlinux.sh
kbuild: link symbol CRCs at final link, removing CONFIG_MODULE_REL_CRCS
[linux.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
3ec8a5b3
MY
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
7d153696
MY
37is_enabled() {
38 grep -q "^$1=y" include/config/auto.conf
39}
40
1f2bfbd0
SR
41# Nice output in kbuild format
42# Will be supressed by "make -s"
43info()
44{
c39013ee 45 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
46}
47
a8cccdd9
ST
48# Generate a linker script to ensure correct ordering of initcalls.
49gen_initcalls()
50{
51 info GEN .tmp_initcalls.lds
52
099c22bd 53 ${PYTHON3} ${srctree}/scripts/jobserver-exec \
a8cccdd9
ST
54 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
55 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
56 > .tmp_initcalls.lds
57}
58
38e89184
ST
59# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
60# .tmp_symversions.lds
61gen_symversions()
62{
63 info GEN .tmp_symversions.lds
64 rm -f .tmp_symversions.lds
65
66 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
67 if [ -f ${o}.symversions ]; then
68 cat ${o}.symversions >> .tmp_symversions.lds
69 fi
70 done
71}
72
1f2bfbd0
SR
73# Link of vmlinux.o used for section mismatch analysis
74# ${1} output file
75modpost_link()
76{
a5967db9 77 local objects
38e89184 78 local lds=""
a5967db9 79
6358d6e8 80 objects="--whole-archive \
d151e971 81 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
82 --no-whole-archive \
83 --start-group \
84 ${KBUILD_VMLINUX_LIBS} \
85 --end-group"
86
7d153696 87 if is_enabled CONFIG_LTO_CLANG; then
a8cccdd9
ST
88 gen_initcalls
89 lds="-T .tmp_initcalls.lds"
90
7d153696 91 if is_enabled CONFIG_MODVERSIONS; then
38e89184 92 gen_symversions
38e89184
ST
93 fi
94
dc5723b0
ST
95 # This might take a while, so indicate that we're doing
96 # an LTO link
97 info LTO ${1}
98 else
99 info LD ${1}
100 fi
101
38e89184 102 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
1f2bfbd0
SR
103}
104
6804c1af
PZ
105objtool_link()
106{
b1a1a1a0 107 local objtoolcmd;
6804c1af
PZ
108 local objtoolopt;
109
ed53a0d9
PZ
110 if is_enabled CONFIG_STACK_VALIDATION && \
111 ( is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT ); then
112
b1a1a1a0
ST
113 # Don't perform vmlinux validation unless explicitly requested,
114 # but run objtool on vmlinux.o now that we have an object file.
7d153696 115 if is_enabled CONFIG_UNWINDER_ORC; then
b1a1a1a0
ST
116 objtoolcmd="orc generate"
117 fi
118
53f7109e 119 objtoolopt="${objtoolopt} --lto"
b1a1a1a0 120
ed53a0d9
PZ
121 if is_enabled CONFIG_X86_KERNEL_IBT; then
122 objtoolopt="${objtoolopt} --ibt"
123 fi
124
7d153696 125 if is_enabled CONFIG_FTRACE_MCOUNT_USE_OBJTOOL; then
b1a1a1a0
ST
126 objtoolopt="${objtoolopt} --mcount"
127 fi
128 fi
129
7d153696 130 if is_enabled CONFIG_VMLINUX_VALIDATION; then
b1a1a1a0
ST
131 objtoolopt="${objtoolopt} --noinstr"
132 fi
133
134 if [ -n "${objtoolopt}" ]; then
135 if [ -z "${objtoolcmd}" ]; then
136 objtoolcmd="check"
137 fi
138 objtoolopt="${objtoolopt} --vmlinux"
7d153696 139 if ! is_enabled CONFIG_FRAME_POINTER; then
6804c1af
PZ
140 objtoolopt="${objtoolopt} --no-fp"
141 fi
7d153696 142 if is_enabled CONFIG_GCOV_KERNEL || is_enabled CONFIG_LTO_CLANG; then
6804c1af
PZ
143 objtoolopt="${objtoolopt} --no-unreachable"
144 fi
7d153696 145 if is_enabled CONFIG_RETPOLINE; then
6804c1af
PZ
146 objtoolopt="${objtoolopt} --retpoline"
147 fi
7d153696 148 if is_enabled CONFIG_X86_SMAP; then
6804c1af
PZ
149 objtoolopt="${objtoolopt} --uaccess"
150 fi
fd6f57bf 151 if is_enabled CONFIG_SLS; then
e463a09a
PZ
152 objtoolopt="${objtoolopt} --sls"
153 fi
6804c1af 154 info OBJTOOL ${1}
b1a1a1a0 155 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
6804c1af
PZ
156 fi
157}
158
1f2bfbd0 159# Link of vmlinux
341dfcf8 160# ${1} - output file
618916a4 161# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
162vmlinux_link()
163{
618916a4 164 local output=${1}
8f130512
MY
165 local objs
166 local libs
5df77ad6
MY
167 local ld
168 local ldflags
169 local ldlibs
1f2bfbd0 170
d7b0827f
LT
171 info LD ${output}
172
618916a4
AN
173 # skip output file argument
174 shift
175
ed53a0d9 176 if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
8f130512
MY
177 # Use vmlinux.o instead of performing the slow LTO link again.
178 objs=vmlinux.o
179 libs=
180 else
181 objs="${KBUILD_VMLINUX_OBJS}"
182 libs="${KBUILD_VMLINUX_LIBS}"
183 fi
184
7b453719
MY
185 if is_enabled CONFIG_MODULES; then
186 objs="${objs} .vmlinux.export.o"
187 fi
188
5df77ad6
MY
189 if [ "${SRCARCH}" = "um" ]; then
190 wl=-Wl,
191 ld="${CC}"
192 ldflags="${CFLAGS_vmlinux}"
193 ldlibs="-lutil -lrt -lpthread"
194 else
195 wl=
196 ld="${LD}"
197 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
198 ldlibs=
199 fi
200
201 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
202
af73d78b
KC
203 # The kallsyms linking does not need debug symbols included.
204 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
5df77ad6 205 ldflags="${ldflags} ${wl}--strip-debug"
af73d78b
KC
206 fi
207
7d153696 208 if is_enabled CONFIG_VMLINUX_MAP; then
5df77ad6 209 ldflags="${ldflags} ${wl}-Map=${output}.map"
5cc12472
RV
210 fi
211
5df77ad6
MY
212 ${ld} ${ldflags} -o ${output} \
213 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
214 ${wl}--start-group ${libs} ${wl}--end-group \
215 $@ ${ldlibs}
1f2bfbd0
SR
216}
217
e83b9f55 218# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
219# ${1} - vmlinux image
220# ${2} - file to dump raw BTF data into
e83b9f55
AN
221gen_btf()
222{
341dfcf8 223 local pahole_ver
e83b9f55 224
581b31c3 225 if ! [ -x "$(command -v ${PAHOLE})" ]; then
2a67a6cc 226 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
341dfcf8 227 return 1
581b31c3
AN
228 fi
229
e83b9f55 230 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
21a85bd6
LB
231 if [ "${pahole_ver}" -lt "116" ]; then
232 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
341dfcf8 233 return 1
e83b9f55
AN
234 fi
235
341dfcf8 236 vmlinux_link ${1}
af73d78b
KC
237
238 info "BTF" ${2}
9741e07e 239 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
341dfcf8 240
90ceddcb
FS
241 # Create ${2} which contains just .BTF section but no symbols. Add
242 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
243 # deletes all symbols including __start_BTF and __stop_BTF, which will
244 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
245 # objcopy warnings: "empty loadable segment detected at ..."
246 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
247 --strip-all ${1} ${2} 2>/dev/null
248 # Change e_type to ET_REL so that it can be used to link final vmlinux.
249 # Unlike GNU ld, lld does not allow an ET_EXEC input.
250 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
e83b9f55 251}
1f2bfbd0 252
08beb669 253# Create ${2} .S file with all symbols from the ${1} object file
1f2bfbd0
SR
254kallsyms()
255{
1f2bfbd0
SR
256 local kallsymopt;
257
7d153696 258 if is_enabled CONFIG_KALLSYMS_ALL; then
6895f97e 259 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
260 fi
261
7d153696 262 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
c6bda7c9
RR
263 kallsymopt="${kallsymopt} --absolute-percpu"
264 fi
265
7d153696 266 if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
2213e9a6
AB
267 kallsymopt="${kallsymopt} --base-relative"
268 fi
269
08beb669
MY
270 info KSYMS ${2}
271 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
1f2bfbd0
SR
272}
273
8959e392
KC
274# Perform one step in kallsyms generation, including temporary linking of
275# vmlinux.
276kallsyms_step()
277{
278 kallsymso_prev=${kallsymso}
af73d78b
KC
279 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
280 kallsymso=${kallsyms_vmlinux}.o
08beb669 281 kallsyms_S=${kallsyms_vmlinux}.S
8959e392 282
d7b0827f 283 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
08beb669
MY
284 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
285
286 info AS ${kallsyms_S}
287 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
288 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
289 -c -o ${kallsymso} ${kallsyms_S}
8959e392
KC
290}
291
1f2bfbd0
SR
292# Create map file with all symbols from ${1}
293# See mksymap for additional details
294mksysmap()
295{
296 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
297}
298
10916706 299sorttable()
1347a2ce 300{
10916706 301 ${objtree}/scripts/sorttable ${1}
1347a2ce
LT
302}
303
1f2bfbd0 304# Delete output files in case of error
1f2bfbd0
SR
305cleanup()
306{
341dfcf8 307 rm -f .btf.*
1f2bfbd0 308 rm -f .tmp_System.map
a8cccdd9 309 rm -f .tmp_initcalls.lds
38e89184 310 rm -f .tmp_symversions.lds
1f2bfbd0
SR
311 rm -f .tmp_vmlinux*
312 rm -f System.map
313 rm -f vmlinux
5cc12472 314 rm -f vmlinux.map
1f2bfbd0 315 rm -f vmlinux.o
0b956e20 316 rm -f .vmlinux.d
e493f472 317 rm -f .vmlinux.objs
7b453719 318 rm -f .vmlinux.export.c
1f2bfbd0
SR
319}
320
1f2bfbd0
SR
321# Use "make V=1" to debug this script
322case "${KBUILD_VERBOSE}" in
323*1*)
324 set -x
325 ;;
326esac
327
328if [ "$1" = "clean" ]; then
329 cleanup
330 exit 0
331fi
332
1f2bfbd0
SR
333# Update version
334info GEN .version
278ae604
MY
335if [ -r .version ]; then
336 VERSION=$(expr 0$(cat .version) + 1)
337 echo $VERSION > .version
1f2bfbd0 338else
278ae604
MY
339 rm -f .version
340 echo 1 > .version
1f2bfbd0
SR
341fi;
342
343# final build of init/
083bc0e1 344${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
1f2bfbd0 345
abac4c89 346#link vmlinux.o
abac4c89 347modpost_link vmlinux.o
6804c1af 348objtool_link vmlinux.o
abac4c89 349
e493f472
MY
350# Generate the list of objects in vmlinux
351for f in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
352 case ${f} in
353 *.a)
354 ${AR} t ${f} ;;
355 *)
356 echo ${f} ;;
357 esac
358done > .vmlinux.objs
359
abac4c89 360# modpost vmlinux.o to check for section mismatches
a721588d 361${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 362
898490c0
AG
363info MODINFO modules.builtin.modinfo
364${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
8b41fc44
MY
365info GEN modules.builtin
366# The second line aids cases where multiple modules share the same object.
367tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
368 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
898490c0 369
7b453719
MY
370if is_enabled CONFIG_MODULES; then
371 ${MAKE} -f "${srctree}/scripts/Makefile.vmlinux" .vmlinux.export.o
372fi
373
7fd78568 374btf_vmlinux_bin_o=""
7d153696 375if is_enabled CONFIG_DEBUG_INFO_BTF; then
af73d78b
KC
376 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
377 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
da5fb182
SF
378 echo >&2 "Failed to generate BTF for vmlinux"
379 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
380 exit 1
341dfcf8
AN
381 fi
382fi
383
1f2bfbd0 384kallsymso=""
8959e392 385kallsymso_prev=""
1f2bfbd0 386kallsyms_vmlinux=""
7d153696 387if is_enabled CONFIG_KALLSYMS; then
1f2bfbd0
SR
388
389 # kallsyms support
390 # Generate section listing all symbols and add it into vmlinux
391 # It's a three step process:
2216cf68 392 # 1) Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
1f2bfbd0
SR
393 # but __kallsyms is empty.
394 # Running kallsyms on that gives us .tmp_kallsyms1.o with
395 # the right size
2216cf68 396 # 2) Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
1f2bfbd0
SR
397 # the right size, but due to the added section, some
398 # addresses have shifted.
2216cf68 399 # From here, we generate a correct .tmp_vmlinux.kallsyms2.o
7e2b37c9
NP
400 # 3) That link may have expanded the kernel image enough that
401 # more linker branch stubs / trampolines had to be added, which
402 # introduces new names, which further expands kallsyms. Do another
403 # pass if that is the case. In theory it's possible this results
404 # in even more stubs, but unlikely.
405 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
406 # other bugs.
407 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
408 #
409 # a) Verify that the System.map from vmlinux matches the map from
410 # ${kallsymso}.
411
8959e392
KC
412 kallsyms_step 1
413 kallsyms_step 2
1f2bfbd0 414
7e2b37c9 415 # step 3
8959e392
KC
416 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
417 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
418
419 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 420 kallsyms_step 3
1f2bfbd0
SR
421 fi
422fi
423
d7b0827f 424vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 425
c9a0f3b8 426# fill in BTF IDs
7d153696 427if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
017dab34
JO
428 info BTFIDS vmlinux
429 ${RESOLVE_BTFIDS} vmlinux
c9a0f3b8
JO
430fi
431
72b3942a
YL
432info SYSMAP System.map
433mksysmap vmlinux System.map
434
7d153696 435if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
10916706 436 info SORTTAB vmlinux
f14bf6a3
SZ
437 if ! sorttable vmlinux; then
438 echo >&2 Failed to sort kernel tables
439 exit 1
440 fi
1347a2ce
LT
441fi
442
1f2bfbd0 443# step a (see comment above)
7d153696 444if is_enabled CONFIG_KALLSYMS; then
1f2bfbd0
SR
445 mksysmap ${kallsyms_vmlinux} .tmp_System.map
446
447 if ! cmp -s System.map .tmp_System.map; then
5369f550 448 echo >&2 Inconsistent kallsyms data
367e43c5 449 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
450 exit 1
451 fi
452fi
0b956e20
RV
453
454# For fixdep
455echo "vmlinux: $0" > .vmlinux.d
This page took 0.449805 seconds and 4 git commands to generate.